/**
 * 动画效果
 * 需要jquery支持
 * author : LiuKing
 * date : 2015-09-25
 */


function randAnnimate()
{
	setInterval("startAnimate()",5000);
}


function startAnimate() {
	var plist = document.getElementById('plist').children;
	var rand = getRandomNum(plist.length);
		
	//2*4+3+3*3+1种效果
	var randAnnimate = getRandomNum(4);
	
	switch (randAnnimate){
		case 0:
			var randSXZY = getRandomNum(3);
//			var sxzyList = ['top','bottom','left','right'];
			var rand01 = getRandomNum(1);
			var trueOrFalse = [true,false];
//			myAnnimate(plist[rand],sxzyList[randSXZY],trueOrFalse[rand01]);
			myAnnimate(plist[rand],randSXZY,trueOrFalse[rand01]);
			break;
		case 1:
			myFade(plist[rand]);
			break;
		case 2:
			mySlide(plist[rand]);
			break;
		case 3:
			var randSpeed = getRandomNum(2);
			var speedList = [20,30,40];
			var randDirect = getRandomNum(2);
			var directList = ['X','Y','Z'];
			startTrans(plist[rand],speedList[randSpeed],directList[randDirect]);
			break;
		case 4:
			startTrans30(plist[rand]);
			break;
		default:
			break;
	}
	
}

/**
 * 获取随机数
 * author : LiuKing
 * date : 2015-09-25
 * @param {Object} max
 */
function getRandomNum(max)
{
	if(max==undefined){
		max = 10;
	}
	var min = 0;
	var ra = parseInt(Math.random()*(max-min+1)+min,10);
	return ra;
}

/**
 * 动画
 * direc:top、bottom、left,right
 * isBackFast:true,false；是否快速恢复
 * author : LiuKing
 * date : 2015-09-25
 */
function myAnnimate(obj,direc,isBackFast)
{
	if(isBackFast==undefined){
		isBackFast = false;
	}
	
//	if(isBackFast){
//		$(obj).animate({direc: '+50px'}, "slow");
//		$(obj).animate({direc: '+0px'}, "fast");
//	}else{
//		$(obj).animate({direc: '+50px'}, "fast");
//		$(obj).animate({direc: '+0px'}, "slow");
//	}

	switch (direc){
		case 0:
			if(isBackFast){
				$(obj).animate({left: '+50px'}, "slow");
				$(obj).animate({left: '+0px'}, "fast");
			}else{
				$(obj).animate({left: '+50px'}, "fast");
				$(obj).animate({left: '+0px'}, "slow");
			}
			break;
		case 1:
			if(isBackFast){
				$(obj).animate({right: '+50px'}, "slow");
				$(obj).animate({right: '+0px'}, "fast");
			}else{
				$(obj).animate({right: '+50px'}, "fast");
				$(obj).animate({right: '+0px'}, "slow");
			}
			break;
		case 2:
			if(isBackFast){
				$(obj).animate({top: '+50px'}, "slow");
				$(obj).animate({top: '+0px'}, "fast");
			}else{
				$(obj).animate({top: '+50px'}, "fast");
				$(obj).animate({top: '+0px'}, "slow");
			}
			break;
		case 3:
			if(isBackFast){
				$(obj).animate({bottom: '+50px'}, "slow");
				$(obj).animate({bottom: '+0px'}, "fast");
			}else{
				$(obj).animate({bottom: '+50px'}, "fast");
				$(obj).animate({bottom: '+0px'}, "slow");
			}
			break;
		default:
			break;
	}
}

/**
 * 淡入淡出
 * author : LiuKing
 * date : 2015-09-25
 */
function myFade(obj)
{
	$(obj).fadeOut("slow");
	$(obj).fadeIn("fast");
}

/**
 * slide
 * author : LiuKing
 * date : 2015-09-25
 */
function mySlide(obj)
{
	$(obj).slideUp();
	$(obj).slideDown();
}

var ttt;
var cnt=0;
var tranObj;
var speed = 1000;
var xyz = "X";

function startTrans(obj,sp,xxx)
{
	tranObj = obj;
	if(sp!=undefined){
		speed = sp;
	}
	if(xxx!=undefined){
		xyz = xxx.toUpperCase();
	}
	trans();
}


/**
 * 旋转
 * author : LiuKing
 * date : 2015-09-25
 */
function trans()
{
	cnt++;
	ttt = setTimeout("trans()",speed);//speed:20,30,40
	//绕x轴翻转
	$(tranObj).css("transform","rotate"+xyz+"("+(10*cnt)+"deg)");
	if(cnt>=36){
		cnt = 0;
		clearTimeout(ttt);	
	}
}

function startTrans30(obj)
{
	tranObj = obj;
	trans30();
}

/**
 * 旋转30deg
 * author : LiuKing
 * date : 2015-09-25
 */
function trans30()
{
	cnt++;
	ttt = setTimeout("trans30()",1000);
	$(tranObj).css("transform","rotateZ(30deg)");
	if(cnt==2){
		$(tranObj).css("transform","rotateZ(0deg)");
	}
	if(cnt==3){
		$(tranObj).css("transform","rotateZ(-30deg)");
	}
	if(cnt>=4){
		$(tranObj).css("transform","rotateZ(0deg)");
		cnt = 0;
		clearTimeout(ttt);
	}
}
