/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		var myreg = /^1[3|4|5|8]\d{9}$/;
		if(loginInfo.account.length==11){
			if(!myreg.test(loginInfo.account)){ 
	           	return callback('账号输入错误');
	        }
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		//加密
		loginInfo.password=hex_sha1(loginInfo.password);
//		var users = JSON.parse(localStorage.getItem('$users') || '[]');
		//后台登录逻辑在这里写
//		var authed = serviceLogin(loginInfo,callback);//后面记得打开注释
//		if (authed) {
//			return owner.createState1(loginInfo.account,owner.moudleId, callback);
//		} 
		return serviceLogin(loginInfo,callback);
	};
	
	/**
	 * 后台登录验证
	 * Author : LMK
	 * Date : 20160526
	 * @param {Object} loginInfo
	 * @return 返回bool是否登录成功
	 */
	var serviceLogin = function(loginInfo,callback){
		var loginResult = false;
		var account = loginInfo.account;
		loginInfo = '{"account": "'+loginInfo.account+'","password":"'+loginInfo.password+'","uuid":"'+plus.device.uuid+'"}';
		var para = {"type":"REQ_APP_LOGIN","jsonStr":loginInfo};
		$.ajax(wurl,{
			data: para,
			dataType: 'json',
			type:'post',
			timeout:5000,
			success:function(data){
				if(data.type!='RES_APP_LOGIN'){
					plus.nativeUI.toast("错误的请求类型");
				}
				var data=JSON.parse(data.jsonStr || '[]');
				var user = JSON.parse(data.entityJson);
				loginResult = data.result;
				if(!loginResult){
					return callback(data.reason);
				}else{
					plus.nativeUI.toast("登录成功，正在加载......");
					return owner.createState1(account,user, callback);
				}
			},
			error:function(xhr,type,errorThrown){
				return callback("登录超时");
			}
		});
	};

	owner.createState = function(name, callback) {
		var state = owner.getState();
		state.account = name;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};
	
	owner.createState1 = function(account, user, callback) {
		var state = owner.getState();
		state.account = account;
		state.token = true;
		state.userId = user.id;
		state.userType = user.userType;
		state.loginName = user.loginName;
		state.trafficMoney = user.transMoney;
		state.mobile = user.mobile;
		state.male = user.male;
		owner.setState(state);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		regInfo.loginName = regInfo.loginName || '';
		regInfo.confirmPasswd = regInfo.confirmPasswd || '';
		regInfo.randomCode = regInfo.randomCode || '';
		regInfo.male = regInfo.male || null;
//		if (regInfo.account.length != 11) {
//			return callback('请输入正确的手机号');
//		}
//		if (regInfo.password.length < 6) {
//			return callback('密码最短需要 6 个字符');
//		}
//		if (!checkEmail(regInfo.email)) {
//			return callback('邮箱地址不合法');
//		}
		Info = '{"mobile": "'+regInfo.account+'","randomCode": "'+regInfo.randomCode+'","passwd":"'+hex_sha1(regInfo.password)+'","confirmPasswd":"'+hex_sha1(regInfo.confirmPasswd)+'","loginName":"'+regInfo.loginName+'","male":'+regInfo.male+'}';
		var para = {"type":"REQ_REGISTER","jsonStr":Info};
		$.ajax(wurl,{
			data: para,
			dataType: 'json',
			type:'post',
			timeout:5000,
			success:function(data){
				if(data.type!='RES_REGISTER'){
					plus.nativeUI.toast("错误的请求类型");
				}
				var data=JSON.parse(data.jsonStr || '[]');
				regResult = data.result;
				if(!regResult){
					plus.nativeUI.toast(data.msg);
				}else{
					plus.nativeUI.toast("注册成功,请登录");
					plus.webview.currentWebview().close();
//					return owner.login(regInfo,callback);
				}
			},
			error:function(xhr,type,errorThrown){
				return callback("注册失败，请重试");
			}
		});
		var users = JSON.parse(localStorage.getItem('$users') || '[]');
		users.push(regInfo);
		localStorage.setItem('$users', JSON.stringify(users));
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};
	
	var checkMobile = function(mobile){
		var myreg = /^1[3|4|5|8]\d{9}$/;
		return myreg.test(mobile);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(resetInfo, callback) {
		callback = callback || $.noop;
		Info = '{"mobile": "'+resetInfo.mobile+'","randomCode": "'+resetInfo.randomCode+'","password":"'+hex_sha1(resetInfo.password)+'","confirmPw":"'+hex_sha1(resetInfo.confirmPw)+'"}';
		var para = {"type":"REQ_FORGETPW","jsonStr":Info};
		$.ajax(wurl,{
			data: para,
			dataType: 'json',
			type:'post',
			timeout:5000,
			success:function(data){
				if(data.type!='RES_FORGETPW'){
					plus.nativeUI.toast("错误的请求类型");
				}
				var data=JSON.parse(data.jsonStr || '[]');
				regResult = data.result;
				if(!regResult){
					return callback(data.msg, null);
				}else{
					return callback(null, '修改成功，请重新登录。');
				}
			},
			error:function(xhr,type,errorThrown){
				return callback("注册失败，请重试",null);
			}
		});
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			return JSON.parse(settingsText);
		}
		/**
		 * 获取本地是否安装客户端
		 **/
	owner.isInstalled = function(id) {
		if (id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if (mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch (e) {}
		} else {
			switch (id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	}
}(mui, window.app = {}));